#include <vcl.h>
#pragma hdrstop

#include "CommandLine.h"
#include <string>
#include <stdio.h>

//---------------------------------------------------------------------------

#pragma package(smart_init)

namespace {


	std::string UrlDecode(const std::string &SRC) {
		std::string ret;
		char ch;
		int i, ii;
		for (i=0; i<SRC.length(); i++) {
			if (int(SRC[i])=='%') {
				sscanf(SRC.substr(i+1,2).c_str(), "%x", &ii);
				ch=static_cast<char>(ii);
				ret+=ch;
				i=i+2;
			} else {
				ret+=SRC[i];
			}
		}
		return (ret);
	}

	AnsiString CleanNumber(AnsiString asNumber)
	{
		AnsiString nr = "";
		for(int i=1; i<=asNumber.Length(); i++)
		{
			if((asNumber[i] >= '0' && asNumber[i] <= '9') || asNumber[i]=='*' ||
				asNumber[i]=='#' || asNumber[i]=='+')
			{
				nr += asNumber[i];
			}
		}
		return nr;
	}
}

CommandLine CommandLine::instance;


CommandLine::CommandLine(void):
	action(ACTION_NONE)
{
}

int CommandLine::Process(void)
{
	char *data = NULL;
	int paramcnt = ParamCount() + 1;
	if (paramcnt <= 1)
		return 0;

	data = new char[paramcnt * MAX_CMD_PARAM_LEN];
	char *buf = data;
	for (int i=0; i<paramcnt; i++)
	{
		strncpy(buf + (MAX_CMD_PARAM_LEN*i), ParamStr(i).c_str(), MAX_CMD_PARAM_LEN);
		buf[MAX_CMD_PARAM_LEN*i + MAX_CMD_PARAM_LEN-1] = '\0';
	}

	// check for previous app instance
	HWND hWnd = FindWindow("TfrmMain", "tSIP");
	if (hWnd)
	{
		// Forward the command line in a WM_COPYDATA message to other instance.
		COPYDATASTRUCT cds;
		cds.cbData = paramcnt * MAX_CMD_PARAM_LEN;
		cds.lpData = buf;
		DWORD dwRetVal;
		if (SendMessageTimeout(hWnd, WM_COPYDATA, 0, (LPARAM)&cds, SMTO_NORMAL, 5000, &dwRetVal))
		{
			//ShowMessage("WM_COPYDATA sent");
		}
		else
		{
        	//ShowMessage("WM_COPYDATA: failed to send");
		}
		delete[] data;
		return 1;
	}
	else
	{
        delete[] data;
		Execute(buf, paramcnt);
	}
	
	return 0;
}

void CommandLine::Execute(char* buf, int paramcnt)
{
	for (int i=1; i<=paramcnt; i++)
	{
		const char* const szCallParam = "/tsip=";
		AnsiString asParam = buf + (MAX_CMD_PARAM_LEN*i);
		if (LowerCase(asParam).Pos(szCallParam))
		{
			AnsiString asCallTo =
				asParam.SubString(strlen(szCallParam)+1, asParam.Length() - strlen(szCallParam)).Trim();

			int i = asCallTo.Pos(":");
			if (i)
				asCallTo = asCallTo.SubString(i+1, asCallTo.Length()-i);

			asCallTo = UrlDecode(asCallTo.c_str()).c_str();

			if (asCallTo == "HANGUP")
			{
				action = ACTION_HANGUP;
			}
			else
			{
				asTarget = CleanNumber(asCallTo);
				if (asTarget.Length())
				{
					action = ACTION_CALL;
				}
			}
		}
	}
}

